<template>
  <div id="material_upload_wrapper">
    <!-- 세션 자료 및 영상 업로드 -->
    <h3>{{ $t('LECTURE_MANAGE.UPLOAD_VIDEO') }}</h3>

    <el-select v-model="mediaType">
      <el-option 
        v-for="media in mediaList"
        :key="media.value"
        :label="media.label"
        :value="media.value">
      </el-option>
    </el-select>
    <el-input v-if="mediaType === 'youtube'" v-model="modifiedLink" style="width: 400px" :placeholder="$t('VIDEO.ENTER_URL')">
      <!-- <el-button slot="append" @click="onClick('UPLOAD_KEYWORDS_AND_VIDEO')">{{ $t('VIDEO.REGISTER') }}</el-button> -->
    </el-input>
    <el-input v-if="mediaType === 'vimeo'" v-model="vimeoId" style="width: 400px" :placeholder="$t('VIDEO.ENTER_VIMEO_URL')">
      <!-- <el-button slot="append" @click="onClick('UPLOAD_KEYWORDS_AND_VIDEO')">{{ $t('VIDEO.REGISTER') }}</el-button> -->
    </el-input>
    <el-upload
      v-if="mediaType === 'audioFile'"
      action="#"
      :auto-upload="false"
      :file-list="initialFileList"
      :limit=1
      :on-change="handleChange"
      :on-exceed="handleExceed"
      :on-remove="handleRemove"
      list-type="picture"
      ref="lectureAudioUpload">
      <el-button slot="trigger" type="primary">{{ $t('NOTE.ADD_FILE') }}</el-button>
      <span slot="tip" class="el-upload__tip"> {{ $t('VIDEO.ONLY_MP3') }}</span>
    </el-upload>
    <audio v-if="mediaType === 'audioFile' && blobURL" controls :src="blobURL"></audio>
    <br><br>
    <youtube
      v-if="youtubeId !== '' && mediaType === 'youtube'"
      :video-id="youtubeId"
      :player-width="displaySize.width"
      :player-height="displaySize.height"
      :player-vars="{ autoplay: 1, modestbranding: 1 }"
      >
    </youtube>
    <iframe
      v-if="vimeoId !== '' && mediaType === 'vimeo'"
      :src="`https://player.vimeo.com/video/${vimeoId.split('/')[vimeoId.split('/').length - 1]}`"
      width="800" height="450" frameborder="0" allow="autoplay; fullscreen" allowfullscreen>
    </iframe>
    <br><br>
   <!-- <el-button @click="centerDialogVisible = true">키워드 선택</el-button>
    <el-dialog
      title="키워드선택"
      :visible.sync="centerDialogVisible"
      width="40%">
      <div>
        <el-checkbox-group v-model="checkList">
          <el-checkbox v-for="item in input.lectureKeyword" :key="item.keyword" :label="item.keyword" >{{item.keyword}}</el-checkbox>
        </el-checkbox-group>
        <el-input id="input_keyword_point" v-model="input.keywordPoint" placeholder="배점" style="width: 200px"></el-input>
        <el-button @click="onClick('ADD_KEYWORD')" style="width: 100px">추가</el-button><br><br>
      </div>
    </el-dialog> <br><br> -->
    <!--
    <div v-for="(item,index) in input.assignedKeywordList" :key="item.keyword" style="display: inline-block;">
      <el-button>{{ item.keyword }} :: {{ item.weight }}점</el-button>
      <el-button @click="onClick('DELETE_KEYWORD',index)" type="danger" style="margin: 0px 10px 0px 0px">X</el-button>
    </div>
   -->
  <el-button @click="centerDialogVisible = true">{{ $t('VIDEO.SELECT_KEYWORD') }}</el-button>
    <el-dialog   
      :title="$t('VIDEO.SELECT_KEYWORD')"
      :visible.sync="centerDialogVisible"
      width="40%">
      <table id="table_design" :data="checkList">
        <thead>
          <tr>
            <td>{{ $t('KEYWORD.LEC_KEY') }}</td>
            <td>{{ $t('LECTURE_MANAGE.ALLOTS') }}</td>
          </tr>
        </thead>
        <tbody>
            <tr v-for="(k, index) in input.lectureKeyword" :key="index">
            <td>
              <el-input v-model="k.keyword" v-show="k.edit"></el-input>
              <span v-show="!k.edit">{{ k.keyword }}</span>
            </td>
            <td>
              <el-input-number  v-model="k.keywordPoint"  :controls=false ></el-input-number>
              <!--<span v-show=k.keywordPoint> </span> -->
            </td>
            <!-- <td>
              <el-button type="small" @click="onClick('ADD_KEYWORD')">추가</el-button>
              <el-button type="small" @click="onClick('DELETE_TAG')">삭제</el-button> 
            </td> -->
          </tr>
        </tbody>
      </table>
      <el-button type="small" align = "right" style="margin: 0px 10px 0px 0px" @click="onClick('ADD_KEYWORD',centerDialogVisible=false)">{{ $t('LECTURE_MANAGE.ADD') }}</el-button>
    </el-dialog><br>
    <div v-for="(item,index) in input.assignedKeywordList" :key="item.keyword" style="display: inline-block;">
      <el-button>{{ item.keyword }} :: {{ item.weight }} {{ $t('LECTURE_MANAGE.SCORE') }}</el-button>
      <el-button @click="onClick('DELETE_KEYWORD',index)" type="danger" style="margin: 0px 10px 0px 0px">X</el-button>
    </div>
    <br><br>
    <el-button @click="onClick('UPLOAD_')" type='primary'>{{ $t('VIDEO.REGISTER') }}</el-button>
    <el-button @click="onClick('DELETE_VIDEO')" type="danger">{{ $t('VIDEO.DELETE') }} </el-button>
    </div>
<!--
    <el-autocomplete
      class="input-new-tag"
      v-model="input.keywordName"
      :fetch-suggestions="querySearch"
      ref="saveTagInput"
      placeholder="키워드"
    />
    <div style="display: inline-block; width: 100px;">
      <el-input id="input_keyword_point" v-model="input.keywordPoint" placeholder="배점"></el-input>
    </div>
    <el-button @click="onClick('ADD_KEYWORD')">추가</el-button><br>
    <div v-for="(item,index) in input.assignedKeywordList" :key="item.keyword" style="display: inline-block;">
      <el-button>{{ item.keyword }} :: {{ item.weight }}점</el-button>
      <el-button @click="onClick('DELETE_KEYWORD',index)" type="danger" style="margin: 0px 10px 0px 0px">X</el-button>
    </div> 
-->
 <!-- </div>  -->
</template>
<script>
import { mapState } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import lectureService from '../../services/lectureService';
import fileService from '../../services/fileService';

export default {
  name: 'MaterialUpload',
  data() {
    return {
      videolink: '',
      modifiedLink: '',
      centerDialogVisible: false,
      checkList: [],
      keywordPoint: [],
      input: {
        assignedKeywordList: [],
        lectureKeyword: [],
      },
      mediaType: 'youtube',
      initialFileList: [],
      mediaList: [
        {
          label: this.$t('NOTE.YOUTUBE'),
          value: 'youtube',
        },
        {
          label: 'vimeo',
          value: 'vimeo',
        },
        // {
        //   label: '음성 녹음',
        //   value: 'voiceRecording',
        // },
        {
          label: this.$t('VIDEO.MP3_UPLOAD'),
          value: 'audioFile',
        },
      ],
      blobURL: '',
      youtubeId: '',
      vimeoId: '',
      displaySize: {
        width: undefined,
        height: undefined,
      },
    };
  },
  // 페이지 로딩시 강의자료와 키워드들 불러오기
  async mounted() {
    const vm = this;
    const lectures = await lectureService.getLecture({
      lectureId: vm.$route.params.lectureId,
    });
    if (lectures.data.media_type !== null) {
      vm.mediaType = lectures.data.media_type;
    }
    let width = window.innerWidth || document.body.clientWidth;
    vm.displaySize.width = width * 0.8 * 0.4;
    vm.displaySize.height = vm.displaySize.width / 16 * 9;
    if (vm.mediaType === 'youtube') {
      vm.videolink = lectures.data.video_link;
      if (vm.videolink !== undefined && vm.videolink !== '' && vm.videolink !== null) {
        vm.youtubeId = getIdFromURL(vm.videolink);
      }
      vm.modifiedLink = lectures.data.video_link;
    }
    if (vm.mediaType === 'vimeo') {
      vm.videolink = lectures.data.video_link;
      vm.vimeoId = vm.videolink;
      vm.modifiedLink = vm.videolink;
    }
    if (vm.mediaType === 'audioFile') {
      const file = await fileService.getFile({ guid: lectures.data.audio_guid });
      vm.$refs.lectureAudioUpload.uploadFiles.push({ name: 'voice' }); // TODO: 파일 이름 가져오기
      vm.blobURL = URL.createObjectURL(file.data);
    }
    const videokeyword = await lectureService.getMainVideoKeyword({
      lectureId: vm.$route.params.lectureId,
    });
    videokeyword.data.forEach((element) => {
      vm.input.assignedKeywordList.push(element);
    });
    const lckeyword = await lectureService.getLectureKeywords({
      lectureId: vm.$route.params.lectureId,
    });
    lckeyword.data.forEach((element) => {
      vm.input.lectureKeyword.push(element);
    });
    vm.input.lectureKeyword.forEach((x) =>{
      x.keywordPoint = 0;
    });
  },
  computed: {
    ...mapState('keyword', [
      'keywordList',
    ]),
    modifiedKeywordList() {
      const vm = this;
      return vm.keywordList.map(x => ({ value: x.keyword }));
    },
  },
  methods: {
    handleExceed() {
      const vm = this;
      vm.$message.warning(vm.$t('WARNING.MAX_NUMBER_FILE'));
    },
    handleChange(file, filelist) {
      const vm = this;
      if (!(['audio/mp3', 'audio/mpeg'].includes(file.raw.type))) { // TODO: 특정 환경에서 .mp3 파일을 업로드해도 audio/mpeg로 올라가는 현상이 발생. 원인 파악이 필요함
        this.$message.warning(vm.$t('NOTIFY.WRONG_FILE_FORMAT'));
        vm.$refs.lectureAudioUpload.uploadFiles.pop();
      } else {
        vm.blobURL = file.url;
      }
    },
    handleRemove() {
      const vm = this;
      vm.blobURL = null;
    },
    querySearch(queryString, cb) {
      const vm = this;
      const results = queryString ?
        vm.modifiedKeywordList.filter(vm.createFilter(queryString)) : vm.modifiedKeywordList;
      // call callback function to return suggestions
      cb(results);
    },
    createFilter(queryString) { // eslint-disable-next-line
      return (link) => {
        return (link.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
      };
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'ADD_KEYWORD': {
          if(vm.input.lectureKeyword.length>vm.checkList.length){
           for(let i=0; i<vm.input.lectureKeyword.length;i++){
              vm.checkList.push(0);
              if(vm.checkList.length===vm.input.lectureKeyword.length){
                break;
              }
            }
          }

          if(vm.input.lectureKeyword.length!==0){
            for(let i=0; i<vm.input.lectureKeyword.length;i++){
              if(vm.input.lectureKeyword[i].keywordPoint/*!==null && vm.input.lectureKeyword[i].keywordPoint!=="" &&vm.input.lectureKeyword[i].keywordPoint!==0*/){
              if(vm.input.lectureKeyword[i].keywordPoint!==""){vm.checkList[i]=1;}
              }
            }
          }

          for(let i=0; i<vm.input.lectureKeyword.length;i++){
            if(vm.input.lectureKeyword[i].keywordPoint==="" || vm.input.lectureKeyword[i].keywordPoint===null ||
                vm.input.lectureKeyword[i].keywordPoint===0){
                  vm.checkList[i]=0;
            }
          }

          for(let i=0; i<vm.input.lectureKeyword.length; i++){// eslint-disable-line
            if(vm.input.lectureKeyword[i].keywordPoint!==null && vm.input.lectureKeyword[i].keywordPoint!==""
                && vm.input.lectureKeyword[i].keywordPoint!==0 && (vm.input.lectureKeyword[i].keywordPoint>100 || vm.input.lectureKeyword[i].keywordPoint<1)){// eslint-disable-line
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.BETWEEN_ONE_HUND'),
                type: 'warning',
                }
              );
              return;
            }
            if(typeof vm.input.lectureKeyword[i].keywordPoint!=="number"){
              vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.BETWEEN_ONE_HUND'),
              type: 'warning',});
              return;
            }
          }
          let check_1=0;
          for(let i=0; i<vm.checkList.length;i++){// eslint-disable-line
            check_1=0;
            if(vm.checkList[i]===1){
              for(let j=0; j<vm.input.assignedKeywordList.length;j++){
                if(vm.input.lectureKeyword[i].keyword===vm.input.assignedKeywordList[j].keyword){
                  vm.input.assignedKeywordList[j].weight=vm.input.lectureKeyword[i].keywordPoint;
                  check_1=1;
                  break;}}
              if(check_1===0){
                vm.input.assignedKeywordList.push({
                        keyword:vm.input.lectureKeyword[i].keyword,
                        weight:vm.input.lectureKeyword[i].keywordPoint
                      });}}}
                      break;
        }
        case 'DELETE_KEYWORD': {
          for(let i=0; i<vm.input.lectureKeyword.length;i++){
            if(vm.input.assignedKeywordList[arg].keyword===vm.input.lectureKeyword[i].keyword){
              vm.input.lectureKeyword[i].keywordPoint=0;
            }
          }
          vm.input.assignedKeywordList.splice(arg, 1);
          break;
        }
        case 'UPLOAD_KEYWORDS_AND_VIDEO': {
          // 키워드 있는지 검사
          if (vm.input.assignedKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.CRE_FAIL'),
              message: vm.$t('NOTIFY.REG_LEAST_PR_KEY'),
              type: 'error',
              duration: 5000,
            });
            return;
          }
          try {
            // 기존 키워드 삭제
            await lectureService.deleteMainVideoKeyword({
              lectureId: vm.$route.params.lectureId,
            });
            // 키워드 업로드
            await lectureService.postMainVideoKeyword({
              lectureId: vm.$route.params.lectureId,
              type: 0,
              data: vm.input.assignedKeywordList,
            });
            // 영상 업로드
            vm.videolink = vm.modifiedLink;
            await lectureService.putLecture({
              lecture_id: vm.$route.params.lectureId,
              video_link: vm.videolink,
            });
            vm.$notify({
              title: 'Success',
              message: vm.$t('NOTIFY.VID_KEY_SUCS_REG'),
              type: 'success',
              duration: 5000,
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.VID_KEY_REG_FAIL'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }
          break;
        }
        case 'UPLOAD_': {
          // 키워드 있는지 검사
          if (vm.input.assignedKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.CRE_FAIL'),
              message: vm.$t('NOTIFY.REG_LEAST_PR_KEY'),
              type: 'error',
              duration: 5000,
            });
            return;
          }
          try {
            // 기존 키워드 삭제
            await lectureService.deleteMainVideoKeyword({
              lectureId: vm.$route.params.lectureId,
            });
            // 키워드 업로드
            await lectureService.postMainVideoKeyword({
              lectureId: vm.$route.params.lectureId,
              type: 0,
              data: vm.input.assignedKeywordList,
            });
            // 영상 업로드
            if (vm.mediaType === 'youtube') {
              vm.videolink = vm.modifiedLink;
              await lectureService.putLecture({
                lecture_id: vm.$route.params.lectureId,
                video_link: vm.videolink,
                media_type: vm.mediaType,
              });
              vm.youtubeId = getIdFromURL(vm.videolink);
            } else if (vm.mediaType === 'audioFile') { // 음성 파일 업로드
              // TODO '새 파일이 있으면' 조건 추가
              if (vm.$refs.lectureAudioUpload.uploadFiles[0] !== undefined &&
                vm.$refs.lectureAudioUpload.uploadFiles[0].raw !== undefined) {
                const res = await lectureService.postLectureAudioFile({
                  file: vm.$refs.lectureAudioUpload.uploadFiles[0].raw,
                });
                // 강의 테이블에 guid 업로드
                await lectureService.putLecture({
                  lecture_id: vm.$route.params.lectureId,
                  audio_guid: res.data.fileGuid,
                  media_type: vm.mediaType,
                });
              }
            } else if (vm.mediaType === 'vimeo') { // Vimeo 업로드 추가
              vm.videolink = vm.vimeoId;
              await lectureService.putLecture({
                lecture_id: vm.$route.params.lectureId,
                video_link: vm.videolink,
                media_type: vm.mediaType,
              });
            }
            vm.$notify({
              title: 'Success',
              message: vm.$t('NOTIFY.VID_KEY_SUCS_REG'),
              type: 'success',
              duration: 5000,
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.VID_KEY_REG_FAIL'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }
          break;
        }
        case 'DELETE_VIDEO': {
          // 영상이 없을 때 <- 맵핑된 키워드가 없을 때
          if (vm.input.assignedKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.DELETE_FAIL'),
              message: vm.$t('NOTIFY.NO_VIDEO'),
              type: 'error',
              duration: 5000,
            });
            return;
          }          
          try {
            // 기존 키워드, 영상 삭제
            await lectureService.deleteMainVideoKeyword({
              lectureId: vm.$route.params.lectureId,
            });
            vm.input.assignedKeywordList = [];
            if(vm.mediaType === 'youtube') {
              vm.videolink = '';
              vm.modifiedLink = '';
              vm.youtubeId = '';
              await lectureService.putLecture({
                lecture_id: vm.$route.params.lectureId,
                video_link: '',
                media_type: '',
              });
            } else if (vm.mediaType === 'audioFile') {
              vm.blobURL = '';
              vm.initialFileList = [];
              await lectureService.putLecture({
                lecture_id: vm.$route.params.lectureId,
                audio_guid: '',
                media_type: '',
              });
            } else if (vm.mediaType === 'vimeo') {
              vm.videolink = '';
              vm.vimeoId = '';
              await lectureService.putLecture({
                lecture_id: vm.$route.params.lectureId,
                video_link: '',
                media_type: '',
              });
            }
            vm.$notify({
              title: 'Success',
              message: vm.$t('NOTIFY.VID_KEY_DEL'),
              type: 'success',
              duration: 5000,
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.VID_KEY_DEL_FAIL'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }
          break;
        }
        default : {
          break;
        }
      }
    },
  },
};
</script>
<style>
#table_design {
    border-collapse: collapse;
    text-align: center;
    line-height: 1.5;
    border-top: 1px solid #321;
    border-bottom: 1px solid #321;
    border-block-end: 1px solid #321;
    margin: 20px 10px;
}
#table_design thead {
    width: 350px;
    padding: 10px;
    vertical-align: top;
    color: #111;
    background: rgb(160, 213, 250);
    margin: 20px 10px;
}
#table_design td {
    width: 350px;
    padding: 10px;
    font-size: 15px;
    color: #333;
}
#table_design tbody {
    border-bottom: 1px solid #321;
}
</style>